diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
index a1ee5acc8..95d6d5b68 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonHead.java
@@ -11,28 +11,32 @@ import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.support.FullSupport;
 import net.minecraft.core.block.support.ISupport;
 import net.minecraft.core.block.support.PartialSupport;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
+import net.minecraft.core.item.Item;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.item.Items;
 import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.ICarrySource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.Vector3d;
 import org.joml.primitives.AABBd;
 import org.joml.primitives.AABBdc;
 
-public class BlockLogicPistonHead extends BlockLogic {
-    public static final int MASK_DIRECTION = 0b0000_0111;
-    public static final int MASK_TYPE = 0b1111_1000;
-    public static final int TYPE_NORMAL = 0;
-    public static final int TYPE_STICKY = 1;
-    public static final int TYPE_STEEL = 2;
+import static net.minecraft.core.block.piston.PistonCommon.*;
 
-    private final double headThickness;
-    private final double shaftThickness;
+public class BlockLogicPistonHead extends BlockLogic implements ICarrySource {
+
+    // "Good lord. This really is our most NSFW update" -- Jonk
+    final double headThickness, shaftThickness;
 
     public BlockLogicPistonHead(final Block<?> block, final double headThickness, final double shaftThickness) {
         super(block, Materials.PISTON);
@@ -41,25 +45,6 @@ public class BlockLogicPistonHead extends BlockLogic {
         this.shaftThickness = shaftThickness;
     }
 
-    @Override
-    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
-        super.onRemoved(world, tilePos, data);
-        Direction direction = getDirectionFromMeta(data);
-        if (direction == Direction.NONE) {
-            return;
-        }
-        Direction orientation = direction.getOpposite();
-        TilePos nextPos = tilePos.add(orientation, new TilePos());
-        Block<?> block = world.getBlockType(nextPos);
-        if (block != null && block.getLogic() instanceof BlockLogicPistonBase) {
-            int data2 = world.getBlockData(nextPos);
-            if (BlockLogicPistonBase.isPowered(data2)) {
-                block.dropWithCause(world, EnumDropCause.PROPER_TOOL, nextPos, data2, null, null);
-                world.setBlockTypeNotify(nextPos, Blocks.AIR);
-            }
-        }
-    }
-
     @Override
     public boolean isSolidRender() {
         return false;
@@ -72,106 +57,174 @@ public class BlockLogicPistonHead extends BlockLogic {
 
     @Override
     public @NotNull ISupport getSupport(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
-        int meta = world.getBlockData(tilePos);
-        return getDirectionFromMeta(meta).getSide() == side ? FullSupport.INSTANCE : PartialSupport.INSTANCE;
+        int data = getValidatedHeadData(world, tilePos);
+        return (DIRECTION.get(data) == side.id)
+        ? FullSupport.INSTANCE 
+        : PartialSupport.INSTANCE;
     }
 
     @Override
     public boolean canPlaceAt(@NotNull World world, @NotNull TilePosc tilePos) {
         return false;
     }
-
+    
     @Override
     public boolean canPlaceOnSide(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side) {
         return false;
     }
-
-
+    
     @Override
     public void getCollisionAABBs(@NotNull World world, @NotNull TilePosc tilePos, @NotNull AABBdc aabb, @NotNull List<@NotNull AABBdc> aabbList) {
-        switch (getDirectionFromMeta(world.getBlockData(tilePos))) {
-            case DOWN -> {
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                addIntersectingBoundingBox(aabb, new AABBd(0.5 - this.shaftThickness / 2, this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 + this.headThickness, 0.5 + this.shaftThickness / 2).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-            }
-            case UP -> {
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                addIntersectingBoundingBox(aabb, new AABBd(0.5 - this.shaftThickness / 2, -this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 - this.headThickness, 0.5 + this.shaftThickness / 2).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-            }
-            case NORTH -> {
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                addIntersectingBoundingBox(aabb, new AABBd(0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 + this.headThickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-            }
-            case SOUTH -> {
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                addIntersectingBoundingBox(aabb, new AABBd(0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, -this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2, 1 - this.headThickness).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-            }
-            case WEST -> {
-                addIntersectingBoundingBox(aabb, new AABBd(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                addIntersectingBoundingBox(aabb, new AABBd(this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, 1 + this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-            }
-            case EAST -> {
-                addIntersectingBoundingBox(aabb, new AABBd(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-                addIntersectingBoundingBox(aabb, new AABBd(-this.headThickness, 0.5 - this.shaftThickness / 2, 0.5 - this.shaftThickness / 2, 1 - this.headThickness, 0.5 + this.shaftThickness / 2, 0.5 + this.shaftThickness / 2).translate(tilePos.x(), tilePos.y(), tilePos.z()), aabbList);
-            }
-        }
+        final var halvedShaft = shaftThickness / 2;
+        
+        final Vector3d hmin = new Vector3d(0), hmax = new Vector3d(1);
+        final Vector3d smin = new Vector3d(0.5 - halvedShaft), smax = new Vector3d(0.5 + halvedShaft);
+        
+        final var dir = Direction.fromId(DIRECTION.get(getValidatedHeadData(world, tilePos)));
+        final int cidx = dir.componentIndex();
+        final boolean neg = dir.isNegative();
+
+        if (neg) hmax.setComponent(cidx, headThickness);
+            else hmin.setComponent(cidx, 1 - headThickness);
+          
+        final var sstart = (neg) ? this.headThickness : -this.headThickness;
+        smin.setComponent(cidx, sstart);
+        smax.setComponent(cidx, sstart + 1);
+        
+        final var pos = new Vector3d(tilePos.vec());
+        addIntersectingBoundingBox(aabb, new AABBd(hmin, hmax).translate(pos), aabbList);
+        addIntersectingBoundingBox(aabb, new AABBd(smin, smax).translate(pos), aabbList);
+    }
+
+    @Override
+    public @NotNull AABBdc getSelectionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
+        final Vector3d min = new Vector3d(0), max = new Vector3d(1);
+        // if (!isBaseless(source.getBlockData(tilePos))) {
+        //     final int i = getDirectionFromMeta(source.getBlockData(tilePos)).getId();
+        //     final int j = (i/2 + 1) % 3;
+        //     final boolean n = (i & 1) == 0;
+        //     if (n) max.setComponent(j, 1 + headThickness);
+        //       else min.setComponent(j, 0 - headThickness);
+        // }
+        return new AABBd(min, max).translate(new Vector3d(tilePos.vec()));
     }
 
     @Override
     public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
-        return switch (getDirectionFromMeta(source.getBlockData(tilePos))) {
-            case DOWN -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, this.headThickness, 1.0F);
-            case UP -> new AABBd(0.0F, 1 - this.headThickness, 0.0F, 1.0F, 1.0F, 1.0F);
-            case NORTH -> new AABBd(0.0F, 0.0F, 0.0F, 1.0F, 1.0F, this.headThickness);
-            case SOUTH -> new AABBd(0.0F, 0.0F, 1 - this.headThickness, 1.0F, 1.0F, 1.0F);
-            case WEST -> new AABBd(0.0F, 0.0F, 0.0F, this.headThickness, 1.0F, 1.0F);
-            case EAST -> new AABBd(1 - this.headThickness, 0.0F, 0.0F, 1.0F, 1.0F, 1.0F);
-            default -> super.getBoundsFromState(source, tilePos);
-        };
+        final Vector3d min = new Vector3d(0), max = new Vector3d(1);
+
+        final var dir = Direction.fromId(DIRECTION.get(getValidatedHeadData(source, tilePos)));
+        final int cidx = dir.componentIndex();
+        final boolean neg = dir.isNegative();
+
+        if (neg) max.setComponent(cidx, headThickness);
+            else min.setComponent(cidx, 1 - headThickness);
+
+        return new AABBd(min, max);
     }
 
     @Override
     public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
-        Direction direction = getDirectionFromMeta(world.getBlockData(tilePos));
-        if (direction == Direction.NONE) {
-            return;
-        }
-        TilePos posOffset = tilePos.sub(direction, new TilePos());
-        Block<?> offsetBlock = world.getBlockType(posOffset);
-        if (offsetBlock.getLogic() instanceof BlockLogicPistonBase) {
-            offsetBlock.onNeighborChanged(world, posOffset, block);
-        } else {
-            world.setBlockTypeNotify(tilePos, Blocks.AIR);
-        }
+        final var data = getValidatedHeadData(world, tilePos);
+        if (IS_DETACHED.bool(data)) return;
+
+        final var bpos = new TilePos(tilePos).sub(Direction.fromId(DIRECTION.get(data)));
+        if (!(world.getBlockType(bpos).getLogic() instanceof BlockLogicPistonBase)) return;
+        int bdat = fixLegacyBaseData(world, bpos);
+        if (PAIR_COMPARISON.get(data ^ bdat) != 0) return;
+
+        world.getBlockType(bpos).onNeighborChanged(world, bpos, block);
     }
 
     @Override
     public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
-        return Material.PISTON_CANT_PUSH;
-    }
-
-    public static Direction getDirectionFromMeta(int meta) {
-        return Direction.getDirectionById(meta & MASK_DIRECTION);
+        return (IS_DETACHED.bool(getValidatedHeadData(world, tilePos)))
+            ? Material.PISTON_PUSHABLE 
+            : Material.PISTON_CANT_PUSH;
     }
 
-    public static int getPistonType(int data) {
-        return ((data & 0xFF) & MASK_TYPE) >> 3;
+    @Override
+    public void onRemoved(@NotNull World world, @NotNull TilePosc tilePos, int data) {
+        data = validateHeadData(data);
+        if (IS_DETACHED.bool(data)) return;
+
+        final var bpos = new TilePos(tilePos).sub(Direction.fromId(DIRECTION.get(data)));
+        if (!(world.getBlockType(bpos).getLogic() instanceof BlockLogicPistonBase)) return;
+        int bdat = fixLegacyBaseData(world, bpos);
+        if (PAIR_COMPARISON.get(data ^ bdat) != 0) return;
+        bdat = IS_DETACHED.set(bdat, 1);
+        if (TYPE.get(bdat) == TYPE_STICKY) {
+            bdat = TYPE.set(bdat, TYPE_NORMAL);
+            world.setBlockTypeData(bpos, Blocks.PISTON_BASE, bdat);
+        } else {
+            world.setBlockData(bpos, bdat);
+        }
+        world.markBlockDirty(bpos);
+        world.triggerEvent(bpos, EVENT_DETACH, 0);
     }
 
-    public static int setPistonType(int type, int data) {
-        return ((data & ~MASK_TYPE) | (type << 3)) & 0xFF;
+    @Override
+    public void onDestroyedByPlayer(
+        @NotNull World world, @NotNull TilePosc tilePos, @NotNull Side side, int data,
+        @NotNull Player player, @Nullable Item item
+    ) {
+        data = validateHeadData(data);
+        if (IS_DETACHED.bool(data)) return;
+        
+        final var bpos = new TilePos(tilePos).sub(Direction.fromId(DIRECTION.get(data)));
+        if (!(world.getBlockType(bpos).getLogic() instanceof BlockLogicPistonBase)) return;
+        int bdat = fixLegacyBaseData(world, bpos);
+        bdat = IS_DETACHED.set(bdat, 0);
+        if (PAIR_COMPARISON.get(data ^ bdat) != 0) return;
+        
+        final var b = world.getBlockType(bpos).getLogic();
+        world.setBlockTypeNotify(bpos, Blocks.AIR); // onRemoved
+        
+        if (player.gamemode.hasItemDrops()) {
+            b.dropWithCause(world, EnumDropCause.WORLD, bpos, bdat, null, null);
+        }
     }
 
     @Override
-    public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
+    public @NotNull ItemStack @Nullable [] getBreakResult(
+        @NotNull World world, @NotNull EnumDropCause dropCause, @NotNull TilePosc tilePos,
+        int data, @Nullable TileEntity tileEntity
+    ) {
+        // handle middle click pick block properly
         if (dropCause == EnumDropCause.PICK_BLOCK) {
-            return switch (getPistonType(data)) {
-                case TYPE_NORMAL -> new ItemStack[]{new ItemStack(Blocks.PISTON_BASE)};
-                case TYPE_STICKY -> new ItemStack[]{new ItemStack(Blocks.PISTON_BASE_STICKY)};
-                case TYPE_STEEL -> new ItemStack[]{new ItemStack(Blocks.PISTON_BASE_STEEL)};
-                default -> null;
-            };
+            if (IS_DETACHED.bool(data)) return null;
+            
+            // we assume head is attached to an actual matching base without performing tilepos lookup
+            int baseData = IS_EXTENDED.set(data, 1);
+            return BASE_BLOCK_MAP[TYPE.get(data)].getBreakResult(world, dropCause, baseData, null);
         }
-        return null;
+
+        return this.getBreakResult(world, dropCause, data, tileEntity);
+    }
+    
+    @Override
+    public @NotNull ItemStack @Nullable [] getBreakResult(
+        @NotNull World world, @NotNull EnumDropCause dropCause,
+        int data, @Nullable TileEntity tileEntity
+    ) {
+        class Result { final static ItemStack[][] LUT = {
+            { new ItemStack(Blocks.PLANKS_OAK, 3) },
+            { new ItemStack(Blocks.PLANKS_OAK, 3), new ItemStack(Items.SLIMEBALL) },
+            { new ItemStack(Items.INGOT_STEEL_CRUDE, 3) },
+        }; }
+        
+        if (dropCause == EnumDropCause.PICK_BLOCK) return null;
+        if (!IS_DETACHED.bool(data)) return null;
+        return Result.LUT[TYPE.get(data)];
+    }
+
+    @Override
+    public @NotNull ICarriable pickup(@NotNull World world, @NotNull Entity holder, @NotNull TilePosc tilePos) {
+        final var hdat = getValidatedHeadData(world, tilePos);
+        
+        world.setBlockType(tilePos, Blocks.AIR); // onRemoved
+        world.notifyBlockChange(tilePos, this.block);
+
+        return new CarriedPistonHead((byte)TYPE.get(hdat));
     }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
index 192fc82fd..9cf4d026d 100644
--- a/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/BlockLogicPistonMoving.java
@@ -8,11 +8,13 @@ import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.item.ItemStack;
-import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
 import net.minecraft.core.world.WorldSource;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.pos.TilePosc;
+
+import java.util.List;
+
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.joml.primitives.AABBd;
@@ -54,20 +56,6 @@ public class BlockLogicPistonMoving extends BlockLogic {
         return false;
     }
 
-    @Override
-    public boolean onInteracted(@NotNull World world, @NotNull TilePosc tilePos, @NotNull Player player, @Nullable Side side, double xHit, double yHit) {
-        if (!world.isClientSide && world.getTileEntity(tilePos) == null) {
-            @NotNull Block<?> block = Blocks.AIR;
-            if (world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
-                block = piston.getMovedBlock();
-            }
-            world.setBlockTypeNotify(tilePos, block);
-            return true;
-        } else {
-            return false;
-        }
-    }
-
     @Override
     public ItemStack[] getBreakResult(@NotNull World world, @NotNull EnumDropCause dropCause, int data, @Nullable TileEntity tileEntity) {
         return null;
@@ -75,62 +63,52 @@ public class BlockLogicPistonMoving extends BlockLogic {
 
     @Override
     public void dropWithCause(@NotNull World world, @NotNull EnumDropCause dropCause, @NotNull TilePosc tilePos, int data, @Nullable TileEntity tileEntity, @Nullable Player player) {
-        if (world.isClientSide) {
-            return;
-        }
+        if (world.isClientSide) return;
         if (world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
-            piston.getMovedBlock().dropWithCause(world, EnumDropCause.WORLD, tilePos, data, null, null);
+            piston.movingBlock().dropWithCause(world, EnumDropCause.WORLD, tilePos, data, null, null);
         }
     }
-
+    
     @Override
     public void onNeighborChanged(@NotNull World world, @NotNull TilePosc tilePos, final @NotNull Block<?> block) {
-        if (!world.isClientSide) {
-            world.getTileEntity(tilePos); // Im not sure if this actually does anything anymore??
+        if (world.isClientSide) return;
+        if (!(world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock)) {
+            world.setBlockType(tilePos, Blocks.AIR);
         }
     }
 
-    public static TileEntity createTileEntity(final @NotNull Block<?> movedBlock, int movedData, @Nullable TileEntity movedEntity, @NotNull Direction direction, boolean extending, boolean isSourcePiston) {
-        assert !(movedEntity instanceof TileEntityMovingPistonBlock) : "Moving piston entity should not be able to be put into another moving piston!";
-        return new TileEntityMovingPistonBlock(movedBlock, movedData, movedEntity, direction, extending, isSourcePiston);
+    @Override
+    public void getCollisionAABBs(
+        @NotNull World world, @NotNull TilePosc tilePos,
+        @NotNull AABBdc aabb, @NotNull List<@NotNull AABBdc> aabbList
+    ) {
+        if (!(world.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock moving)) {
+            super.getCollisionAABBs(world, tilePos, aabb, aabbList);
+            return;
+        }
+        if (moving.isExtending || !moving.isSourcePiston) {
+            super.getCollisionAABBs(world, tilePos, aabb, aabbList);
+            return;
+        }
+        aabbList.add(this.getCollisionAABB(world, tilePos));
+        // prevents entities from phasing into piston base
+        aabbList.add(new AABBd(0, 0, 0, 1, 1, 1).translate(tilePos.x(), tilePos.y(), tilePos.z()));
+        return;
     }
 
     @Override
     public @Nullable AABBdc getCollisionAABB(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
-        if (source.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
-            float progress = piston.getProgress(0.0F);
-            if (piston.isExtending()) {
-                progress = 1.0F - progress;
-            }
-            return getCollisionShapeFromTileEntity(source, tilePos, piston.getMovedBlock(), progress, piston.getDirection());
+        if (!(source.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock moving)) {
+            return null;
         }
-        return null;
+        return moving.collision;
     }
 
     @Override
     public @NotNull AABBdc getBoundsFromState(@NotNull WorldSource source, @NotNull TilePosc tilePos) {
         if (source.getTileEntity(tilePos) instanceof TileEntityMovingPistonBlock piston) {
-            Block<?> block = piston.getMovedBlock();
-            if (block == this.block) {
-                return super.getBoundsFromState(source, tilePos);
-            }
-            float directionStretch = piston.getProgress(0.0F);
-            if (piston.isExtending()) {
-                directionStretch = 1.0F - directionStretch;
-            }
-            Direction direction = piston.getDirection();
-            AABBdc otherBounds = block.getBoundsFromState(source, tilePos);
-            return otherBounds.translate(-direction.getOffsetX() * directionStretch, -direction.getOffsetY() * directionStretch, -direction.getOffsetZ() * directionStretch, new AABBd());
+            return piston.bounds;
         }
         return super.getBoundsFromState(source, tilePos);
     }
-
-    public @Nullable AABBdc getCollisionShapeFromTileEntity(@NotNull WorldSource source, @NotNull TilePosc tilePos, final @NotNull Block<?> block, float directionStretch, @NotNull Direction direction) {
-        AABBdc aabb = block.getCollisionAABB(source, tilePos);
-        if (aabb == null) {
-            return null;
-        } else {
-            return aabb.translate(-direction.getOffsetX() * directionStretch, -direction.getOffsetY() * directionStretch, -direction.getOffsetZ() * directionStretch, new AABBd());
-        }
-    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/piston/CarriedPistonHead.java b/game/core/src/main/java/net/minecraft/core/block/piston/CarriedPistonHead.java
new file mode 100644
index 000000000..a67feeed1
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/block/piston/CarriedPistonHead.java
@@ -0,0 +1,107 @@
+package net.minecraft.core.block.piston;
+
+import org.jetbrains.annotations.NotNull;
+
+import com.mojang.nbt.tags.CompoundTag;
+
+import net.minecraft.core.block.Block;
+import net.minecraft.core.block.motion.ICarriedBlock;
+import net.minecraft.core.entity.Entity;
+import net.minecraft.core.entity.Mob;
+import net.minecraft.core.enums.PlacementMode;
+import net.minecraft.core.util.helper.Direction;
+import net.minecraft.core.util.helper.Side;
+import net.minecraft.core.world.ICarriable;
+import net.minecraft.core.world.World;
+import net.minecraft.core.world.pos.TilePos;
+
+import static net.minecraft.core.block.piston.PistonCommon.*;
+
+public class CarriedPistonHead implements ICarriable, ICarriedBlock {
+    private @NotNull byte type;
+
+    public CarriedPistonHead(byte type) {
+        this.type = type;
+    }
+
+	@Override
+    public @NotNull Block<? extends BlockLogicPistonHead> block() {
+        return PistonCommon.HEAD_BLOCK_MAP[type];
+    }
+
+    @Override
+    public int metadata() {
+        return metadata(Direction.UP.id);
+    }
+    
+    private int metadata(int dir) {
+        int d = 0;
+        d = IS_DETACHED.set(d, 1);
+        d = TYPE.set(d, this.type);
+        d = DIRECTION.set(d, dir);
+        d = validateHeadData(d);
+        return d;
+    }
+
+    @Override
+    public boolean tryPlace(World world, Entity holder, int blockX, int blockY, int blockZ,
+        Side side, double xPlaced, double yPlaced
+    ) {
+        final var hpos = new TilePos(blockX, blockY, blockZ).add(side.direction());
+        if (!world.canPlaceInsideBlock(hpos)) return false;
+
+        final int dir = (holder instanceof Mob mob)
+            ? mob.getPlacementDirection(side.opposite(), PlacementMode.SIDE).opposite().id
+            : Direction.UP.id;
+
+        int hdat = metadata(dir);
+        world.setBlockType(hpos, block());
+
+        sync_base: {
+            final var bpos = new TilePos();
+            int bdat = headGetBase(hdat, bpos, world, hpos);
+            if (bdat == DATA_INVALID) break sync_base;
+            if (!IS_DETACHED_OR_EXTENDED.bool(bdat)) break sync_base;
+            if (PAIR_COMPARISON.get(hdat ^ bdat) != 0) break sync_base;
+
+            hdat = IS_DETACHED.set(hdat, 0);
+            bdat = IS_DETACHED.set(bdat, 0);
+            bdat = IS_EXTENDED.set(hdat, 1);
+
+            if (IS_STEEL.bool(hdat)) {
+                world.setBlockData(bpos, bdat);
+            } else {
+                bdat = TYPE.setNoShift(bdat, hdat);
+                world.setBlockTypeDataRaw(bpos, BASE_BLOCK_MAP[TYPE.get(hdat)], bdat);
+            }
+            world.triggerEvent(bpos, EVENT_ATTACH, 0);
+        }
+
+        world.setBlockDataNotify(hpos, hdat);
+        return true;
+    }
+
+    @Override
+    public void drop(World world, Entity holder) {
+    }
+
+    @Override
+    public void writeToNBT(CompoundTag tag) {
+        tag.putByte("head_type", type);
+        tag.putString("type", TYPE_PISTON_HEAD);
+    }
+
+    @Override
+    public void readFromNBT(CompoundTag tag) {
+        type = tag.getByte("head_type");
+    }
+
+    public static CarriedPistonHead createAndLoad(CompoundTag tag) {
+        final var carriedBlock = new CarriedPistonHead((byte)0);
+        carriedBlock.readFromNBT(tag);
+        return carriedBlock;
+    }
+
+    @Override
+    public void heldTick(World world, Entity holder) {}
+}
